class PcAnimationLoading extends React.Component
{
  constructor(props)
  {
    super(props);
    this.circles = [];
  }
  setup(renderSize)
  {
    var circleSize = 70*renderSize;
    var radius = 200*renderSize;
    var mainHeight = 400*renderSize;

    var theta = [0, Math.PI / 6, Math.PI / 3, Math.PI / 2, 2 * (Math.PI / 3), 5 * (Math.PI / 6), Math.PI, 7 * (Math.PI / 6), 4 * (Math.PI / 3), 3 * (Math.PI / 2), 5 * (Math.PI / 3), 11 * (Math.PI / 6)];

    for (var i = 0; i < 12; i++)
    {
      let circle = {index:0, x:"", y:"", top:"", left:"", width:"", height:""};
      this.circles.push(circle);
      this.circles[i].index = i;
      this.circles[i].x = Math.round(radius * (Math.cos(theta[i]))) + 'px';
      this.circles[i].y = Math.round(radius * (Math.sin(theta[i]))) + 'px';
      this.circles[i].top = (((mainHeight / 2) - parseInt(this.circles[i].y.slice(0, -2)))-circleSize/2) + 'px';
      this.circles[i].left = (((mainHeight / 2) + parseInt(this.circles[i].x.slice(0, -2)))-circleSize/2) + 'px';
      this.circles[i].width = circleSize;
      this.circles[i].height = circleSize;
      this.circles[i].animation = "circleLoop 0.6s ease-out "+((11-i)*0.05)+"s infinite forwards";
    }
  }

  render()
  {
    let renderSize, bgColor, borderColor, borderWidth;

    if (PcConfig.initialized)
    {
      renderSize = PcConfig.renderSize;
      bgColor = PcConfig.scenario.standardButtonBackgroundColor;
      borderColor = PcConfig.scenario.standardButtonBorderColor;
      borderWidth = PcConfig.scenario.buttonsBorderWidth;
    }
    else {
      renderSize = this.props.renderSize;
      bgColor = "#ffffff";
      borderColor = "#ffffff";
      borderWidth = 1;
    }

    this.setup(renderSize);

    const circles = this.circles.map(item => {
      if (item.x)
      {
        return e('div',
        {
          style:
          {
            position:"absolute",
            backgroundColor:bgColor,
            borderColor:borderColor,
            borderStyle:"solid",
            borderWidth:borderWidth,
            borderRadius:"50%",
            top:item.top,
            left:item.left,
            width:item.width,
            height:item.height,
            opacity:0,
            animation:item.animation,
          },
          key:"circle" + item.index
        }
      );
    }
    });

    return e('div',
      {
        className:"pcelementshowanimation",
        style:
        {
          position:this.props.position ? this.props.position : "absolute",
          opacity:this.props.noAnimation?1:0,
          animation:this.props.noAnimation?"":PcConfig.scenario.elementsAnimationStyle,
          animationFillMode:"forwards",
          animationDelay:this.props.showDelay,
          left:this.props.x,
          top:this.props.y,
        }
      },
      circles
    );
  }
}
