class PcSliderFormats extends React.Component
{
  constructor(props)
  {
    super(props);

    this.reseted = false;
    this.resetTimeout = null;

    this.mainSlides = [];
    for (var i=0; i<PcConfig.screen.format.formats.length; i++) this.mainSlides[i] = React.createRef();

    this.mainSlidesSimpleMode = false;

    this.lastClickTime = Date.now();
    this.autoNextTime = 100*1;
  }

  reset()
  {
    if (this.reseted) return;

    $('.mainslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow:this.mainSlidesSimpleMode ? PcConfig.screen.format.formats.length : 1,
          slidesToScroll: 1,
          centerMode: this.mainSlidesSimpleMode ? false : true,
          variableWidth: true,
          swipeToSlide: this.mainSlidesSimpleMode ? false : true,
          swipeAngleOffset: 90,
          touchThreshold : 10,
          speed:300,
          cssEase:"cubic-bezier(0, 0, 0.1, 1.0)",
          focusOnSelect: true,
          arrows:false,
        });

    $('.mainslider_' + this.props.name).on('beforeChange', (event, slick, currentSlide, nextSlide) =>
    {
      this.changeMainSlide(nextSlide);
    });

    $('.mainslider_' + this.props.name).slick("slickGoTo", PcConfig.getMemory("currentFormatIndex"));
    $('.mainslider_' + this.props.name).slick("setPosition");
    this.lastClickTime = Date.now();
    this.onTouchMainSlide(PcConfig.getMemory("currentFormatIndex"), true);

    for(let i=0; i<this.mainSlides.length; i++) this.mainSlides[i].current.start();

    this.reseted = true;
  }

  changeMainSlide(index)
  {
    if (PcConfig.getMemory("currentFormatIndex")==index)
    {
      return;
    }
    else {
      this.lastClickTime = Date.now();
    }

    PcConfig.setMemory("currentFormat", this.mainSlides[index].current.props.format);
    PcConfig.setMemory("currentFormatIndex", index);
  }

  onTouchMainSlide(index)
  {
    if (PcConfig.getMemory("currentFormatIndex")==index)
    {
      if (Date.now()-this.lastClickTime>this.autoNextTime) this.props.onSelectSlide();
    }

    if (this.mainSlidesSimpleMode)
    {
      this.lastClickTime = Date.now();
      $('.mainslider_' + this.props.name).slick("setSlideClasses", index);
      this.changeMainSlide(index);
    }
  }

  onDoubleTouchMainSlide(index)
  {
    this.onTouchMainSlide(index);

    PcConfig.sounds.buttonNext.play();
    this.props.onSelectSlide();
  }

  delete()
  {
    for(let i=0; i<this.mainSlides.length; i++)
    {
      if (this.mainSlides[i])
      {
        if (this.mainSlides[i].current)
        {
          this.mainSlides[i].current.delete();
        }
        this.mainSlides[i] = null;
      }
    }

    if ($('.mainslider_' + this.props.name)) $('.mainslider_' + this.props.name).slick('unslick');

    for (var i=0; i<PcConfig.screen.format.formats.length; i++) this.mainSlides[i] = React.createRef();
  }

  render()
  {
    if (this.props.active)
    {
      this.mainSlidesSimpleMode = PcConfig.screen.format.formats.length <= 2;
      this.resetTimeout = setTimeout( ()=> {
        this.reset();
      }, 10);
    }
    else {

      clearTimeout(this.resetTimeout);

      if (!this.props.keepState)
      {
        if (this.reseted) this.delete();
        this.reseted = false;
        return null;
      }
    }

    let slideWidth, navWidth, sliderWidth;

    slideWidth = this.props.width * 0.25;
    sliderWidth=0;

    navWidth = this.props.width*0.9*PcConfig.screen.format.formats.length/6;
    if (navWidth>this.props.width*0.9) navWidth = this.props.width*0.9;

    let mainSlides = [];
    let ratio = PcMode.screen.format.slidersRatio;

    for (var i=0; i<PcConfig.screen.format.formats.length; i++)
    {
      let index = i;

      switch (PcConfig.screen.format.formats[i].paper)
      {
          case "10x15" : slideWidth = this.props.width * 0.25 * ratio; break;
          case "15x10" : slideWidth = this.props.width * 0.25 * ratio; break;
          case "5x15" : slideWidth = this.props.width * 0.15 * ratio; break;
          case "15x15" : slideWidth = this.props.width * 0.30 * ratio; break;
      }

      sliderWidth += slideWidth;

      mainSlides[i] = ((i)=>{return e('div',{className:"slick-item", key:"img"+i, onTouchEnd:()=>this.onTouchMainSlide(i), onClick:()=>this.onTouchMainSlide(i), style:{height:this.props.height}},
                    e(PcPhoto,
                      {
                        ref:this.mainSlides[i],
                        animationMode:"",
                        preview:false,
                        label:PcConfig.screen.format.formats[i].label,
                        format:PcConfig.screen.format.formats[i],
                        filter:PcConfig.screen.format.filter,
                        shot:PcCaptureSession.defaultShot,
                        colors:[PcConfig.screen.format.formats[i].defaultSkin.color],
                        backgrounds:[PcConfig.screen.format.formats[i].defaultSkin.background],
                        foregrounds:[PcConfig.screen.format.formats[i].defaultSkin.foreground],
                        width:slideWidth,
                        height:this.props.height,
                        padding:0,
                      }
                    )
                  );})(i);
    }

    let mainSliderLeft = this.mainSlidesSimpleMode ? (this.props.width - sliderWidth)/2 : 0;

    return e('div',
        {
          className:"pcsliderformatscontainer",
          style:
          {
            position:"absolute",
            opacity:0,
            animation:PcConfig.scenario.elementsAnimationStyle,
            animationFillMode:"forwards",
            animationDelay:this.props.showDelay,
            width:this.props.width,
            height:this.props.height,
            left:this.props.x,
            top:this.props.y,
            display:"table-cell",
            textAlign:"center",
          }
        },
        e('div', {className:"mainslider_"+this.props.name, style:{left:mainSliderLeft, width:this.props.width, height:this.props.height}}, mainSlides),
      );
  }
}
