class PcSliderTemplateAndFilter extends React.Component
{
  constructor(props)
  {
    super(props);

    this.reseted = false;

    this.mainSlides = [];
    this.navSlides = []

    this.mainSlidesSimpleMode = false;
    this.navSlidesSimpleMode = false;

    this.lastClickTime = Date.now();
    this.autoNextTime = 100*1;
  }

  reset()
  {
    if (this.reseted) return;

    $('.mainslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow: this.mainSlidesSimpleMode ? this.props.skins[this.props.formatIndex].length : 1,
          slidesToScroll: 1,
          centerMode: this.mainSlidesSimpleMode ? false : true,
          variableWidth: true,
          swipeToSlide: this.mainSlidesSimpleMode ? false : true,
          swipeAngleOffset: 90,
          touchThreshold : 10,
          speed:300,
          cssEase:"cubic-bezier(0, 0, 0.1, 1.0)",
          focusOnSelect: true,
          arrows:false,
        });

    $('.navslider_' + this.props.name).slick(
        {
          infinite: false,
          slidesToShow: this.navSlidesSimpleMode ? PcConfig.screen.templateAndFilter.filters.length : 1,
          slidesToScroll: 1,
          centerMode: this.navSlidesSimpleMode ? false : true,
          variableWidth: true,
          swipeToSlide: this.navSlidesSimpleMode ? false : true,
          swipeAngleOffset: 90,
          touchThreshold : 10,
          speed:300,
          cssEase:"cubic-bezier(0, 0, 0.1, 1.0)",
          focusOnSelect: true,
          arrows:false,
        });

    $('.mainslider_' + this.props.name).on('beforeChange', (event, slick, currentSlide, nextSlide) => {
      this.changeMainSlide(nextSlide);
    });

    $('.navslider_' + this.props.name).on('beforeChange', (event, slick, currentSlide, nextSlide) => {
      this.changeNavSlide(nextSlide);
    });

    $('.mainslider_' + this.props.name).slick("slickGoTo", PcConfig.getMemory("currentSkinIndex"));
    $('.mainslider_' + this.props.name).slick("setPosition");
    this.lastClickTime = Date.now();
    this.onTouchMainSlide(PcConfig.getMemory("currentSkinIndex"), true);

    $('.navslider_' + this.props.name).slick("slickGoTo", PcConfig.getMemory("currentFilterIndex"));
    $('.navslider_' + this.props.name).slick("setPosition");
    this.onTouchNavSlide(PcConfig.getMemory("currentFilterIndex"), true);

    for (let i=0; i<this.mainSlides.length && this.mainSlides[i]!=null; i++) if (this.mainSlides[i]) this.mainSlides[i].current.start();

    this.reseted = true;
  }

  changeMainSlide(index, forced=false)
  {
    //if (PcConfig.getMemory("currentSkinIndex")==index && !forced) return;

    if (PcConfig.getMemory("currentSkinIndex")==index && !forced)
    {
      return;
    }
    else {
      this.lastClickTime = Date.now();
    }

    PcConfig.setMemory("currentSkin", this.mainSlides[index].current.props.skin);
    PcConfig.setMemory("currentSkinIndex", index);
  }

  onTouchMainSlide(index, forced=false)
  {
    if (PcConfig.getMemory("currentSkinIndex")==index)
    {
      if (PcConfig.screen.templateAndFilter.filters.length<=1)
      {
        if (Date.now()-this.lastClickTime>this.autoNextTime) this.props.onSelectSlide();
      }
    }

    if (this.mainSlidesSimpleMode)
    {
      this.lastClickTime = Date.now();
      $('.mainslider_' + this.props.name).slick("setSlideClasses", index);
      this.changeMainSlide(index, forced);
    }
  }

  changeNavSlide(index, forced=false)
  {
    if (PcConfig.getMemory("currentFilterIndex")==index && !forced) return;

    for (let i=0; i<this.mainSlides.length && this.mainSlides[i]!=null; i++)
    {
        this.mainSlides[i].current.setFilter(this.navSlides[index].current.props.filter);
    }

    PcConfig.setMemory("currentFilter", this.navSlides[index].current.props.filter);
    PcConfig.setMemory("currentFilterIndex", index);
  }

  onTouchNavSlide(index, forced=false)
  {
    if (this.navSlidesSimpleMode)
    {
      $('.navslider_' + this.props.name).slick("setSlideClasses", index);
      this.changeNavSlide(index, forced);
    }
  }

  onDoubleTouchMainSlide(index)
  {
    this.onTouchMainSlide(index);
    this.props.onSelectSlide();
  }

  delete()
  {
    for(let i=0; i<this.mainSlides.length; i++)
    {
      if (this.mainSlides[i] && this.mainSlides[i].current)
      {
        this.mainSlides[i].current.delete();
      }
      this.mainSlides[i] = null;
    }

    for(let i=0; i<this.navSlides.length; i++)
    {
      if (this.navSlides[i] && this.navSlides[i].current)
      {
        this.navSlides[i].current.delete();
      }
      this.navSlides[i] = null;
    }

    $('.mainslider_' + this.props.name).slick('unslick');
    $('.navslider_' + this.props.name).slick('unslick');
  }

  componentDidUpdate()
  {
    if (this.props.active) this.reset();
  }

  componentDidMount()
  {
    if (this.props.active) this.reset();
  }

  render()
  {
    if (!this.props.active) return null;

    if (this.props.active && !this.reseted)
    {
      for (var i=0; i<this.props.skins[this.props.formatIndex].length; i++) this.mainSlides[i] = React.createRef();
      for (var i=0; i<PcConfig.screen.templateAndFilter.filters.length; i++) this.navSlides[i] = React.createRef();
      this.mainSlidesSimpleMode = this.props.skins[this.props.formatIndex].length <= 2;
      this.navSlidesSimpleMode = PcConfig.screen.templateAndFilter.filters.length <= 8;
    }
    else {
      if (!this.props.keepState)
      {
        this.reseted = false;
        this.delete();
        return null;
      }
    }

    let currentFilter = PcConfig.screen.templateAndFilter.filters[0];

    let slideWidth, navWidth, sliderWidth;

    let needFilters = (PcConfig.screen.templateAndFilter.filters.length>1);

    let mainSliderHeight = needFilters ? this.props.height*0.66 : this.props.height;
    let navSliderHeight = needFilters ? this.props.height*0.33 : 0;

    slideWidth = this.props.width * 0.25;
    navWidth = this.props.width*0.9*this.props.skins[this.props.formatIndex].length/6;
    if (navWidth>this.props.width*0.9) navWidth = this.props.width*0.9;

    let mainSlides = [];
    let ratio = PcMode.screen.templateAndFilter.slidersRatio;
    sliderWidth = 0;

    switch (PcConfig.screen.format.formats[this.props.formatIndex].paper)
    {
        case "10x15" : slideWidth = this.props.width * 0.25 * ratio; break;
        case "15x10" : slideWidth = this.props.width * 0.4 * ratio; break;
        case "5x15" : slideWidth = this.props.width * 0.12 * ratio; break;
        case "15x15" : slideWidth = this.props.width * 0.25 * ratio; break;
    }

    if (PcConfig.device=="surface") slideWidth *= 1.33;

    sliderWidth = this.props.skins[this.props.formatIndex].length * slideWidth;

    if (this.mainSlidesSimpleMode && sliderWidth>this.props.width)
    {
      slideWidth = this.props.width/2;
      sliderWidth = this.props.width;
    }

    for (var i=0; i<this.props.skins[this.props.formatIndex].length; i++)
    {
      let index = i;

      mainSlides[i] = ((i)=>{return e('div',{className:"slick-item", key:"img"+i, onTouchEnd:()=>this.onTouchMainSlide(i), onClick:()=>this.onTouchMainSlide(i), style:{height:mainSliderHeight}},
                    e(PcPhoto,
                      {
                        ref:this.mainSlides[i],
                        animationMode:"",
                        preview:false,
                        label:"",
                        format:PcConfig.screen.format.formats[this.props.formatIndex],
                        filter:currentFilter,
                        shot: (PcCameraControl.useDSLR()==false && PcCameraControl.webcamActive==false) ? PcCaptureSession.defaultShot : PcCaptureSession.shot,
                        skin:this.props.skins[this.props.formatIndex][i],
                        colors:[this.props.skins[this.props.formatIndex][i].color],
                        backgrounds:[this.props.skins[this.props.formatIndex][i].background],
                        foregrounds:[this.props.skins[this.props.formatIndex][i].foreground],
                        width:slideWidth,
                        height: mainSliderHeight,
                        padding:0,
                      }
                    )
                  );})(i);

    }

    let mainSliderLeft =  this.mainSlidesSimpleMode ? (this.props.width - sliderWidth)/2 : 0;

    let navSlides = [];
    sliderWidth = 0;

    for (var i=0; i<PcConfig.screen.templateAndFilter.filters.length; i++)
    {
      let index = i;

      slideWidth = this.props.width*0.065*PcMode.screen.templateAndFilter.filtersRatio;
      sliderWidth += slideWidth + 15*PcConfig.renderSize*2;

      navSlides[i] = ((i)=>{return e('div',{className:"slick-item", key:"img"+i, onTouchEnd:()=>this.onTouchNavSlide(i), onClick:()=>this.onTouchNavSlide(i), style:{height:navSliderHeight}},
                    e(PcPhoto,
                      {
                        ref:this.navSlides[i],
                        animationMode:"",
                        preview:true,
                        label:PcConfig.screen.templateAndFilter.filters[i].title,
                        format:PcConfig.screen.format.formats[this.props.formatIndex],
                        filter:PcConfig.screen.templateAndFilter.filters[i],
                        shot:(PcCameraControl.useDSLR()==false && PcCameraControl.webcamActive==false) ? PcCaptureSession.defaultShot : PcCaptureSession.shot,
                        colors:[],
                        backgrounds:[this.props.skins[this.props.formatIndex][0].background],
                        foregrounds:[],
                        width:slideWidth,
                        height:slideWidth,
                        padding:15*PcConfig.renderSize,
                      }
                    )
                  );})(i);

    }

    let navSliderLeft =  this.navSlidesSimpleMode ? (this.props.width - sliderWidth) / 2 : 0;

    return e('div',
        {
          className:"pcslidertemplateandfilterscontainer",
          style:
          {
            position:"absolute",
            opacity:0,
            animation:PcConfig.scenario.elementsAnimationStyle,
            animationFillMode:"forwards",
            animationDelay:this.props.showDelay,
            width:this.props.width,
            height:this.props.height,
            left:this.props.x,
            top:this.props.y,
            display:"table-cell",
            textAlign:"center",
          }
        },
        e('div', {className:"mainslider_"+this.props.name, style:{overflow:"hidden", left:mainSliderLeft, width:this.props.width, height:mainSliderHeight}}, mainSlides),
        e('div', {className:"navslider_"+this.props.name, style:{overflow:"hidden", left:navSliderLeft, width:this.props.width, height:navSliderHeight}}, navSlides),
      );
  }
}
