class PcFormEmail extends PcFormElement
{
  constructor(props)
  {
    super(props);

    this.emailInput = React.createRef();
    this.label = React.createRef();
    this.okButton = React.createRef();

    this.state = {okButtonVisible:false}

    if (props.kind=="listing")
    {
      this.currentMode = "id";
      this.labelId = this.props.label.split('|')[0];
      this.labelEmail = this.props.label.split('|')[1];
      this.errorId = this.props.errorMessageEmail.split('|')[0];
      this.errorEmail = this.props.errorMessageEmail.split('|')[1];
    }
    else {
      this.currentMode = "email";
      this.labelId = "";
      this.labelEmail = this.props.label;
      this.errorId = "";
      this.errorEmail = this.props.errorMessageEmail;
    }

    this.listingData = null;
    this.currentListing = [];
    this.currentSelected = null;
  }

  componentDidMount()
  {
      this.readListingFile();
  }

  setFocus()
  {
    ReactDOM.findDOMNode(this.emailInput.current).focus();
  }

  readListingFile()
  {
    $.ajax({
      url: this.props.listingFile,
      type: "POST",
      timeout:5000,
      success: (data)=>{
        this.listingData = data;
        this.listingArray = this.createListingArray(data);
      },
      error: (xhr, status, err)=>{

      }
    });
  }

  createListingArray(data)
  {
    var a = [];
    data = data.replace(/(\r\n|\n|\r)/gm,"[line]");
    var lines = data.split('[line]');
    lines.forEach((item)=>{
        a.push(item.split(";"));
    });

    return a;
  }

  findStringInListing(str)
  {
    var a = [];

    this.listingArray.forEach((item, index)=>
    {
        if (this.findStringInItem(item, str))
        {
          a.push(item);
        }
    });

    a = a.slice(0,PcConfig.global.maxListingEntryCount - 1); // 3 items max
    // add the notinlist item, makes max 4 items total
    a.push(["[notinlist]", PcConfig.screen.infos.textListing, "", undefined]);

    return a;
  }

  findStringInItem(item, str)
  {
    str = str.trim();
    var astr = str.split(' ');
    var found = [];
    var foundcount = 0;

    for (let i=0; i<astr.length; i++)
    {
      item.forEach((subItem, index)=>{
        if (index>0 && !found[i] && subItem.toLowerCase().indexOf(astr[i].toLowerCase())==0)
        {
          found[i] = true;
          foundcount++;
        }
      })
    }

    //if (str.length>=9) item.push(found);

    return (foundcount>=astr.length);
  }

  onInputChange(from)
  { 
    PcConfig.dbg(CRASHDBG, "entering from", from, "with currentMode", this.currentMode, "and currentSelected", this.currentSelected);
    if (this.currentMode=="id" && this.currentSelected!=null)
    {
      this.props.answered("onInputChange mode id "+from, this.currentSelected[0]); // answered comes from the PcForm base class
      PcConfig.setMemory("currentId", this.currentSelected);
      this.setState({okButtonVisible:true});
    }
    else if (this.currentMode=="email")
    {
      this.props.answered("onInputChange mode email "+from, this.emailInput.current.value);
      //PcConfig.setMemory("currentId", "");
    }
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  reset()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    this.setState({okButtonVisible:false})

    this.emailInput.current.value = "";

    if (this.props.listingFile!="")
    {
      this.currentMode = "id";
      this.label.current.updateLabel(this.labelId);
    }
    else {
      this.currentMode = "email";
      this.label.current.updateLabel(this.labelEmail);
    }

    this.emailInput.current.value = "";
    this.onKeyPressed('');
    this.currentListing=[];
    this.currentSelected = null;
    this.forceUpdate();

    this.props.emailInputSwitchMode(this.currentMode);
    PcConfig.dbg(CRASHDBG, "exiting");

  }

  onKeyPressed(key)
  {
    PcConfig.dbg(CRASHDBG, "entering with key", key);
    if (key!="" && (key==PcConfig.keyboard.domain1 || key==PcConfig.keyboard.domain2))
    {
      const ADD_AROBASE_BEFORE_DOMAIN = false; // customer request: domain keys are now prefixed by @
      if ((ADD_AROBASE_BEFORE_DOMAIN === true) && (this.emailInput.current.value.indexOf("@")==-1) )
      {
        key = "@" + key;
      }

      this.emailInput.current.setSelectionRange(this.emailInput.current.value.length, this.emailInput.current.value.length);
    }

    let cpos = this.emailInput.current.selectionStart;
    let s1 = this.emailInput.current.value.substring(0,cpos);
    let s2 = this.emailInput.current.value.substring(cpos,this.emailInput.current.value.length);
    this.emailInput.current.setSelectionRange(cpos, cpos);

    if (key=="⌫")
    {
      if (this.currentSelected!=null)
      {
          this.currentSelected = null;
          PcConfig.setMemory("currentId", "");
          cpos=0; s1=""; s2="";
          this.emailInput.current.value = "";
          this.setState({okButtonVisible:false});
      }

      s1 = s1.substring(0, s1.length-1);
      this.emailInput.current.value = s1 + s2;
      this.emailInput.current.focus();
      if (cpos==0)
      {
        this.emailInput.current.setSelectionRange(0, 0);
      } else {
        this.emailInput.current.setSelectionRange(cpos-1, cpos-1);
      }
    }
    else if (key=="←")
    {
      this.emailInput.current.focus();
      if (cpos>0)
      {
        this.emailInput.current.setSelectionRange(cpos-1, cpos-1);
      }
    }
    else if (key=="→")
    {
      this.emailInput.current.focus();
      this.emailInput.current.setSelectionRange(cpos+1, cpos+1);
    }
    else if (key=="")
    {
      this.emailInput.current.focus();
      //this.emailInput.current.setSelectionRange(cpos+1, cpos+1);
    }
    else
    {
      if (this.currentSelected!=null)
      {
          this.currentSelected = null;
          cpos=0; s1=""; s2="";
          this.emailInput.current.value = "";
          this.setState({okButtonVisible:false});
      }
      this.emailInput.current.value = s1 + key + s2;
      this.emailInput.current.focus();
      this.emailInput.current.setSelectionRange(cpos+key.length, cpos+key.length);
    }

    this.onInputChange("onKeyPressed with key " + key);

    if (this.currentMode == "id")
    {
      if (this.emailInput.current.value.length>=3)
      {
        this.currentListing = this.findStringInListing(this.emailInput.current.value);
        this.forceUpdate();
      }
      else
      {
        this.currentListing=[];
        this.forceUpdate();
      }
    }
    else {
      if (this.validateEmail())
      {
        this.setState({okButtonVisible:true});
      }
      else {
        this.setState({okButtonVisible:false});
      }
    }
  PcConfig.dbg(CRASHDBG, "exiting");
  }

  setValue(v)
  {
    PcConfig.dbg(CRASHDBG, "entering with value", v);
    // console.log("PcFormEmail setValue", v);
    this.emailInput.current.value = v;
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  _onClickList(item)
  {
    if (item[0]!="[notinlist]")
    {
      this.setState({okButtonVisible:true})

      this.emailInput.current.value = item[1] + " " + item[2];
      this.onKeyPressed('');
      this.currentListing=[];
      this.currentSelected = item;
      PcConfig.setMemory("currentId", this.currentSelected);

      for (let i=0; i<PcConfig.screen.infos.questions.length; i++)
      {
        PcConfig.setMemory("question"+i, "");
      }

      this.forceUpdate();
      this.props.answered("_onClickList", this.currentSelected[0]);
    }
    else {
      this.currentMode="email";
      this.emailInput.current.value = "";
      PcConfig.setMemory("currentId", "");
      this.onKeyPressed('');
      this.forceUpdate();
      this.props.emailInputSwitchMode("email");
      this.label.current.updateLabel(this.labelEmail);
    }
  }

  onClickList(item)
  {
      this.setState({okButtonVisible:true})

      this.emailInput.current.value = item[1] + " " + item[2];
      this.onKeyPressed('');
      this.currentListing=[];
      this.currentSelected = item;


      let finalCurrentId = "";
      if (item[0] != "[notinlist]")
      {
        finalCurrentId = this.currentSelected;
      }
      PcConfig.setMemory("currentId", finalCurrentId);
      console.log("currentId", PcConfig.getMemory("currentId"));

      for (let i=0; i<PcConfig.screen.infos.questions.length; i++)
      {
        PcConfig.setMemory("question"+i, "");
      }

      this.forceUpdate();
      this.props.answered("onClickList currentId", this.currentSelected[0]);
      
      if (item[0] != "[notinlist]") {
        setTimeout(()=>{this.props.emailInputSkip()}, 100);
      }
  }

  validateEmail()
  {
    PcConfig.dbg(CRASHDBG, "entering")
    if (/^\w+([.-]\w+)*@\w+([.-]\w+)*\.\w{2,8}$/.test(this.emailInput.current.value))
    {
      return true;
    }
    else {
      return false;
    }
  }

  validate() // prepares error message for a error popup if required  
  {
    let ret;
    PcConfig.dbg(CRASHDBG, "entering with currentMode", this.currentMode);
    if (this.emailInput.current.value=="photocab")
    {
      PcConfig.exitAll();
    }

    if (this.currentMode=="id")
    {
      ret = this.validateIdMode();
      
    }
    else {
      ret = this.validateEmailMode();
    }
    PcConfig.dbg(CRASHDBG, "exiting with ret", ret)
    return ret;
  }

  validateEmailMode()
  {
    var validEmail = false;

    if (this.props.required)
    {
      validEmail = this.validateEmail();
    }
    else {
      if (this.emailInput.current.value.length>0)
      {
        validEmail = this.validateEmail();
      }
      else {
        validEmail = true;
      }
    }

    if (validEmail)
    {
      return "";
    }
    else {
      return this.errorEmail!="" ? this.errorEmail : " ";
    }
  }

  validateIdMode()
  {
    let ret = "";
    PcConfig.dbg(CRASHDBG, "entering with currentSelected", this.currentSelected);
    if (this.currentSelected!=null)
    {
      ret = "";
    }
    else {
      ret = this.errorId!="" ? this.errorId : " ";
    }
    PcConfig.dbg(CRASHDBG, "exiting with ret", ret);
    return ret;
  }

  changeLabel(text)
  {
    this.label.current.updateLabel(text);
  }

  onClickOkButton()
  {
    PcConfig.dbg(CRASHDBG, "entering");
    setTimeout(()=>this.props.okClick(), 10);
    PcConfig.dbg(CRASHDBG, "exiting");
  }

  render()
  {
    var idlist;

    if (this.currentMode=="id")
    {
     idlist = e(PcFormIdList,
        {
          onClick:(item)=>this.onClickList(item),
          width:"100%",
          list:this.currentListing,
          centered:this.props.centered ? "center" : "left",
        }
      );
    }
    else {
      idlist = null;
    }

    const okButton = e(PcFormOkButton,
        {
          key:"okbutton",
          ref:this.okButton,
          onClick:()=>this.onClickOkButton(),
          active:this.props.active,
          label:"",
          sound:PcConfig.sounds.keyboard,
          position:"relative",
          visibility:this.state.okButtonVisible,
          fontSize:PcConfig.scenario.fontSize,
          color: PcConfig.scenario.textColor,
          spacingHLeft:5*PcConfig.renderSize,
          spacingHRight:5*PcConfig.renderSize,
          spacingV:5*PcConfig.renderSize,
          halign:"left",
          showDelay:"0,1s"
        }
      );

    return e('div',
      {
        className:"pcemailcontainer",
        onClick:this.props.onClick,
        style:
        {
          textAlign:this.props.centered ? "center" : "left",
          transition:"all 0.25s ease-out",
        }
      },
        e(PcLabel,
          {
            ref:this.label,
            label:this.props.kind=="listing" ? this.labelId : this.labelEmail,
            position:"relative",
            width:this.props.width,
            height:this.props.height,
            halign : this.props.centered ? "center" : "left",
            fontSize:PcConfig.scenario.fontSize,
            color: PcConfig.scenario.fontColor,
            showDelay:"0,1s"
          }
        ),
        e('div', {style:{width:"100%", height:10*PcConfig.renderSize}}),
        e("input",
          {
            ref:this.emailInput,
            onChange:()=>this.onInputChange("PcFormEmail:onChange"),
            onInput:()=>this.onInputChange("PcFormEmail:onInput"),
            spellCheck:"false",
            style:
              {
                width:"98%",
                height:60*PcConfig.renderSize,
                fontFamily:PcConfig.scenario.fontFamily,
                fontSize:PcConfig.scenario.fontSize,
                color: PcConfig.scenario.fontColor,
                borderStyle:"solid",
                borderWidth:PcConfig.scenario.buttonsBorderWidth/2,
                borderColor:PcConfig.scenario.fontColor,
                borderRadius:12*PcConfig.renderSize,
                paddingLeft:10*PcConfig.renderSize,
                paddingRight:5*PcConfig.renderSize,
                textAlign:this.props.centered ? "center" : "left",
                background: "transparent",
                outline: "none",
              }
          }
        ),
        e('div', {style:{width:"100%", height:10*PcConfig.renderSize}}),
        e(PcLabel,
          {
            ref:this.mention,
            label:this.props.mention,
            position:"relative",
            width:this.props.width,
            height:this.props.height,
            halign : this.props.centered ? "center" : "left",
            fontSize:PcConfig.scenario.fontSizeSmall,
            color: PcConfig.scenario.fontColor,
            showDelay:"0,1s"
          }
        ),
        idlist,
        e("div",
          {
            className:"pcok",
            style:
            {
              position:"relative",
              display:"inline-flex",
              justifyContent: this.props.centered ? "center" : "flex-start",
              flexWrap: "wrap",
              alignContent:"left",
              justifyContent:"left",
              animation:PcConfig.scenario.elementsAnimationStyle,
              animationDelay:this.props.showDelay,
            }
          },
          e('div', {style:{width:"100%", height:10*PcConfig.renderSize}}),
          okButton
        ),
        e('div', {style:{width:"100%", height:100*PcConfig.renderSize}}),
      );

  }

}
