class PcScreenMenuVideo extends PcScreen
{
  constructor(props)
    {
      super(props);

      this.buttons = [];

      for (let i=0; i<PcConfig.screen.menu.themes.length; i++)
      {
        if (PcConfig.screen.menu.themes[i].label=="") break;
        this.buttons[i] = React.createRef();
        this.registerButton(this.buttons[i], PcConfig.screen.menu.themes[i].label);
      }
    }

    normalizeButtons()
    {
        if (this.props.active) setTimeout(()=>{this.normalizeButtonsWidth()}, 10);
    }

    componentDidMount()
    {
        this.normalizeButtons();
    }

    componentDidUpdate()
    {
        this.normalizeButtons();
    }

    buttonClicked(index)
    {
      PcConfig.setMemory('currentTheme', index);
      this.props.goNextScreen();
    }

    render()
    {
      if (!this.props.active) return null;

      const displayButtons = PcConfig.screen.menu.themes.map(item => {

        if (item.label!="")
        {
          var newLine = null;

          if (PcConfig.screen.menu.themes.length<=5)
          {
            newLine = e('div', {key:"separator"+item.index, style:{width:"100%"}});
          }

          return [e(PcButton,
            {
              ref:this.buttons[item.index],
              label:item.label,
              onClick:()=>{this.buttonClicked(item.index)},
              showDelay: item.index/15 + "s",
              key:item.index,
              spacingH: 20 * PcConfig.renderSize,
              spacingV: 20 * PcConfig.renderSize,
              borderColor: PcConfig.scenario.actionButtonBorderColor,
              backgroundColor: PcConfig.scenario.actionButtonBackgroundColor,
              fontColor: PcConfig.scenario.actionButtonTextColor,
              sound : PcConfig.sounds.buttonNext
            }
          ),
          newLine]
        }
      });

      return e('div',
        {
          className:this.state.className,
          index:this.props.index,
          style:
          {
            display: (this.props.active ? 'block' : 'none'),
            fontFamily:PcConfig.scenario.fontFamily,
            animation:this.props.noAnimation?"":this.state.animationStyle
          },
        },
        e(PcMedia,
          {
            content:"",//PcConfig.screen.menu.foreground,
            width:this.props.width,
            height:this.props.height,
          }
        ),
        e(PcLabel,
          {
            label:PcConfig.screen.menu.title,
            width:this.props.width,
            height:this.props.height*(0.1),
            x:0,
            y:this.props.height*(0.03),
            fontSize:PcConfig.scenario.fontSizeBig,
            color: PcConfig.scenario.fontColor,
            showDelay:"0,1s"
          }
        ),
        e('div',
          {
            style:
              {
                position:"absolute",
                width:"90%",
                height:"70%",
                top:"15%",
                left:"5%",
                display:"inline-flex",
                justifyContent: "center",
                flexWrap: "wrap",
                alignItems:"center",
                alignContent:"center",
              }
          },
          displayButtons
        ),
        e('div',
          {
            style:
              {
                position:"absolute",
                width:"100%",
                top:"85%",
                height:"15%",
                display:"inline-flex",
                justifyContent: "center",
                alignItems:"center",
                alignContent:"space-around",
              }
          },
          e(PcButton,
            {
              ref:this.buttons["previous"],
              label:PcConfig.screen.menu.previousButton.title,
              onClick:this.props.goPrevScreen,
              borderColor: PcConfig.screen.menu.previousButton.borderColor,
              backgroundColor: PcConfig.screen.menu.previousButton.backgroundColor,
              fontColor: PcConfig.screen.menu.previousButton.fontColor,
              sound : PcConfig.sounds.button,
              showDelay:"0.4s"
            }
          )
        )
      );
    }
}
