class PcScreenTemplateAndFilter extends PcScreen
{
  constructor(props)
  {
    super(props);

    this.buttons = [];
    this.buttons["previous"] = React.createRef();
    this.buttons["next"] = React.createRef();

    this.registerButton(this.buttons["previous"], PcConfig.screen.templateAndFilter.previousButton.title);
    this.registerButton(this.buttons["next"], PcConfig.screen.templateAndFilter.nextButton.title);
  }

  normalizeButtons()
  {
    setTimeout(()=>{this.normalizeButtonsWidth()}, 10);
  }

  componentDidMount()
  {
      if (this.props.active) this.normalizeButtons();
  }

  componentDidUpdate()
  {
      if (this.props.active) this.normalizeButtons();
  }

  render()
  {
    if (!this.props.active) return null;

    let skins;

    if (PcConfig.getMemory("winner")==1)
    {
      skins = PcConfig.instantWin.lots[PcConfig.getMemory("winnerLot")];
    }
    else {
      skins = PcConfig.screen.templateAndFilter.skins;
    }

    let framingAlert = "";
    let framingAlertDesc = "";

    if (PcConfig.framingAlert.length>0)
    {
      framingAlert = PcConfig.framingAlert[0];

      framingAlertDesc = PcConfig.screen.templateAndFilter.framingText1 + "\n";

      switch (framingAlert)
      {
        case "face" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextFace; break;
        case "size" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextSize; break;
        case "up" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextUp; break;
        case "down" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextDown; break;
        case "right" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextLeft; break;
        case "left" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextRight; break;
      }

      framingAlertDesc += "\n\n" + PcConfig.screen.templateAndFilter.framingText2;
    }

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.props.noAnimation?"":this.state.animationStyle
        },
      },
      e(PcLabel,
        {
          label: framingAlert!="" ? framingAlertDesc : ( PcConfig.getMemory("winner")==1 ? PcConfig.instantWin.title : PcConfig.screen.templateAndFilter.title ),
          title:true,
          width:this.props.width*0.9,
          height:framingAlert!="" ? this.props.height*0.4 : this.props.height*0.1,
          x:this.props.width*0.05,
          y:this.props.height*(PcMode.screen.templateAndFilter.titleY),
          fontSize:PcConfig.scenario.fontSizeBig,
          color: PcConfig.scenario.fontColor,
          showDelay:"0,1s",
        }
      ),
      (framingAlert!="") ? null : e(PcSliderTemplateAndFilter,
        {
          active: this.props.active,
          keepState: this.props.keepState,
          name:"templateandfilter",
          format:PcConfig.getMemory("currentFormat"),
          formatIndex:PcConfig.getMemory("currentFormatIndex"),
          filters:PcConfig.screen.templateAndFilter.filters,
          skins:skins,
          onSelectSlide:()=>{PcConfig.sounds.buttonNext.play(); this.props.goNextScreen()},
          x:0,
          y:this.props.height*(PcMode.screen.templateAndFilter.sliderY),
          width:this.props.width,
          height:this.props.height*(PcMode.screen.templateAndFilter.sliderH),
          showDelay:"0.2s"
        }
      ),
      e('div',
        {
          style:
            {
              position:"absolute",
              width:"100%",
              top:this.props.height * (PcMode.screen.templateAndFilter.buttonsY),
              display:"inline-flex",
              justifyContent: "space-evenly"
            }
        },
        e(PcButton,
          {
            ref:this.buttons["previous"],
            label:framingAlert!="" ?  PcConfig.screen.templateAndFilter.framingButtonLabel : PcConfig.screen.templateAndFilter.previousButton.title,
            fontColor:PcConfig.screen.templateAndFilter.previousButton.fontColor,
            borderColor:PcConfig.screen.templateAndFilter.previousButton.borderColor,
            backgroundColor:PcConfig.screen.templateAndFilter.previousButton.backgroundColor,
            prevArrow:true,
            align:"right",
            onClick:this.props.goPrevScreen,
            sound : PcConfig.sounds.buttonPrevious,
            showDelay:"0.3s"
          }
        ),
        (framingAlert!="") ? null : e(PcButton,
          {
            ref:this.buttons["next"],
            label: PcConfig.screen.templateAndFilter.nextButton.title,
            fontColor:PcConfig.screen.templateAndFilter.nextButton.fontColor,
            borderColor:PcConfig.screen.templateAndFilter.nextButton.borderColor,
            backgroundColor:PcConfig.screen.templateAndFilter.nextButton.backgroundColor,
            nextArrow:true,
            animated:true,
            kind: "action",
            onClick:this.props.goNextScreen,
            sound : PcConfig.sounds.buttonNext,
            showDelay:"0.4s"
          }
        )
      )
    );
  }
}
